#include <algorithm>
#include <iostream>
using namespace std;

/**
 * Lessons
 *  - XOR
 *  - Reading strings from cin
 */
int main() {
	int T;
	cin >> T;

	for(int test = 0; test < T; test++) {
		int n, m;
		cin >> n >> m;
		bool row_xor[n];
		bool col_xor[m];
		for(int row = 0; row < n; row++) {
			row_xor[row] = false;
		}
		for(int col = 0; col < m; col++) {
			col_xor[col] = false;
		}

		for(int row = 0; row < n; row++) {
			string s;
			cin >> s;
			for(int col = 0; col < m; col++) {
				bool curr = s[col] == '1';
				row_xor[row] = row_xor[row] ^ curr;
				col_xor[col] = col_xor[col] ^ curr;
			}
		}

		int row_count = 0, col_count = 0;
		for(bool row : row_xor) {
			if(row) row_count++;
		}
		for(bool col : col_xor) {
			if(col) col_count++;
		}
		cout << max(row_count, col_count) << '\n';
	}

	return 0;
}

